#include "generic/SortedArrayList.h"
#include "int/intSortedArrayList.h"
#include "string/stringSortedArrayList.h"
#include <iostream>

using namespace std;

int main(){

	ListInterface<int>* lists[2];
	lists[0] = new ArrayList<int>(10);
	lists[1] = new SortedArrayList<int>(10);

	lists[0]->add(5);
	lists[0]->add(10);
	lists[0]->add(7);
	cout << "printing lists[0]: ";
	lists[0]->print();

	lists[1]->add(5);
        lists[1]->add(10);
        lists[1]->add(7);
	cout << "printing lists[1]: ";
        lists[1]->print();

	delete lists[0];
	delete lists[1];
	
	intArrayList* int_lists[2];
        int_lists[0] = new intArrayList(10);
        int_lists[1] = new intSortedArrayList(10);

        int_lists[0]->add(5);
        int_lists[0]->add(10);
        int_lists[0]->add(7);
        cout << "printing int_lists[0]: ";
        int_lists[0]->print();

        int_lists[1]->add(5);
        int_lists[1]->add(10);
        int_lists[1]->add(7);
        cout << "printing intlists[1]: ";
        int_lists[1]->print();

	delete int_lists[0];
	delete int_lists[1];

	stringArrayList* string_lists[2];
        string_lists[0] = new stringArrayList(10);
        string_lists[1] = new stringSortedArrayList(10);

        string_lists[0]->add("5");
        string_lists[0]->add("10");
        string_lists[0]->add("7");
        cout << "printing string_lists[0]: ";
        string_lists[0]->print();

        string_lists[1]->add("5");
        string_lists[1]->add("10");
        string_lists[1]->add("7");
        cout << "printing string_lists[1]: ";
        string_lists[1]->print();

	delete string_lists[0];
	delete string_lists[1];
	
	return 1;
}


