#include "intArrayList.h"
#include <iostream>


intArrayList::intArrayList(int capacity){
		std::cout << "intArrayList construction is running...\n"; 
		listArray_ = new int[capacity]; 
		n_=0; 
		capacity_ = capacity;
	}
	
bool intArrayList::empty() const{return n_==0;};
	
int intArrayList::count() const{return n_;}
	
void intArrayList::print() const{ 
		for (int i=0; i<n_; i++) 
			std::cout << listArray_[i] << " ";
		std::cout << std::endl;
	}

bool intArrayList::removeFirst(const int& elem){
		int index = findFirst(elem); 
		if (index==-1){
			std::cout << "removing " << elem << " failed!\n";
			return false;
		}
		for (int i=index; i<n_-1; i++)
			listArray_[i] = listArray_[i+1];
		n_--;	
		std::cout << "just removed " << elem << std::endl;
		return true;	
	}

bool intArrayList::add(const int& new_entry){
		if (n_+1 > capacity_){ // array is full
			std::cout << "adding " << new_entry << " failed\n";
			return false;
		}
		listArray_[n_] = new_entry;
		n_++;
		std::cout << "just added " << new_entry << std::endl; 
		return true;
	}

intArrayList::~intArrayList() {
		std::cout << "intArrayList destruction is running...\n";
		delete [] listArray_; 
	}

int intArrayList::findFirst(const int& elem) const{
		for (int i=0; i<n_; i++)
			if (listArray_[i] == elem)
				return i;
		return -1;
	}

